﻿
using System;

namespace RocketGM.PanStats
{
    public abstract class BaseStat
    {
        public abstract string StringValue { get; }
	    public event Action Changed;
        public bool SyncRemote { get; protected set; }

        protected BaseStat(bool syncRemote)
        {
            SyncRemote = syncRemote;
        }

		public abstract T Get<T>();

        public virtual bool Set<T>(T value)
        {
            IsDirty = true;

            return true;
        }

        private bool _isDirty;
        public bool IsDirty
        {
            get { return _isDirty; }
            set
            {
                _isDirty = value;

                if (!value) return;
                if (Changed != null) Changed();
            }
        }
        /// <summary>
        /// Returns the type of stat
        /// </summary>
        /// <returns></returns>
        public abstract Type GetStatType();

        protected virtual void ValidateType(Type type)
        {
            if (type != GetStatType())
            {
                throw new InvalidCastException();
            }
        }
    }
}
