﻿using System;
using CodeStage.AntiCheat.ObscuredTypes;

namespace RocketGM.PanStats
{
    public class BoolStat : BaseStat
    {
        public override string StringValue => Current.ToString();
        public ObscuredBool Current { get; private set; }
        public BoolStat(bool current, bool syncRemote = true) : base(syncRemote)
        {
            Current = current;
        }

        public override T Get<T>()
        {
            ValidateType(typeof(T));

            return (T)Convert.ChangeType((bool)Current, typeof(T));
        }

        public override bool Set<T>(T value)
        {
            ValidateType(typeof(T));

            bool newValue = Convert.ToBoolean(value);

            if (newValue == Current)
                return false;

            Current = newValue;

            return base.Set(newValue);
        }

        public override Type GetStatType()
        {
            return typeof(bool);
        }
    }
}
