﻿using System;
using CodeStage.AntiCheat.ObscuredTypes;

namespace RocketGM.PanStats
{
    public class StringStat : BaseStat
    {
        public override string StringValue => Current;

        public ObscuredString Current { get; protected set; }

        public StringStat(string current, bool syncRemote = true) : base(syncRemote)
        {
            Current = current;
        }

	    public virtual void Reconstruct(string value, bool syncRemote)
        {
            SyncRemote = syncRemote;
        }

	    public override T Get<T>()
        {
            ValidateType(typeof(T));

            return (T) Convert.ChangeType((string)Current, typeof(T));
        }

        public override bool Set<T>(T value)
        {
            ValidateType(typeof(T));

            string newValue = Convert.ToString(value);

            if (newValue == Current)
                return false;

            Current = newValue;

            return base.Set(newValue);
        }

        public override Type GetStatType()
        {
            return typeof(string);
        }
    }
}
