﻿using System;
using System.Diagnostics;
using UnityEngine;

namespace RocketGM
{
	[Serializable]
	public class PlayerProgress
	{
		public string stepName;
		public int stepCount;
		public int stepDuration;
		public int status;

		private float _duration;

		public string Key
		{
			get { return stepName + status; }
		}

		private readonly Stopwatch _stopwatch = new Stopwatch();

		public PlayerProgress()
		{
		}

		public PlayerProgress(string stepName, float duration = 0)
		{
			this.stepName = stepName;
			this._duration = duration;
			_stopwatch.Start();
		}

		public void Pause()
		{
			if (!_stopwatch.IsRunning) return;

			_stopwatch.Stop();
		}

		public void Resume()
		{
			if (_stopwatch.IsRunning) return;
		    
			_stopwatch.Start();
		}

	    public void SaveDuration()
	    {	        
            _stopwatch.Stop();

            stepDuration += Mathf.RoundToInt((float)_stopwatch.Elapsed.TotalSeconds);
            stepDuration += Mathf.RoundToInt(_duration);

	        _stopwatch.Reset();
        }

	    public void Finalize(int targetStatus)
		{
			status = targetStatus;
			stepCount = 1;

		    SaveDuration();
        }
	}
}
