﻿using System;
using System.Collections.Generic;
using RocketLog;
using RocketUtils;
using Object = System.Object;

namespace RocketGM
{
    public class RocGmHelper
    {
        private static readonly RocLog Log = new RocLog(nameof(RocGmHelper), DebugLevels.Info);

        public static bool TryGetServerResult(string response, out Dictionary<String, Object> result)
        {
            try
            {
				result = Json.Deserialize(response) as Dictionary<String, Object>;
				

				int serverReturnCode = -1;

                if (result == null || !result.ContainsKey("ServerReturnCode")
                                   || !int.TryParse(result["ServerReturnCode"].ToString(), out serverReturnCode)
                                   || serverReturnCode != 0)
                {
                    Log.Error("Server Error! ServerReturnCode: " + serverReturnCode
                                                                 + (result != null &&
                                                                    result.ContainsKey("ServerReturnCode")
                                                                     ? " result[\"ServerReturnCode\"] = " +
                                                                       result["ServerReturnCode"]
                                                                     : ""));

                    return false;
                }

                return true;

            }
            catch (Exception)
            {
                Log.Warning("Response CAN NOT be parsed: " + response);
                result = null;
                return false;
            }
        }
    }
}


