﻿using RocketGM;
using RocketLog;

namespace RocketGames
{
	/// <summary>
	/// Use this class for game related changes.
	/// </summary>
    public class RocGmController : RocGmControllerBase
    {
	    protected override void OnAwake()
	    {
	        base.OnAwake();

#if (ROC_DEBUG_MODE || ROC_LOG_MODE)
            DrawDebugLabel = true;
#endif
        }

	    protected override void OnApplicationPause(bool pauseStatus)
	    {
		    base.OnApplicationPause(pauseStatus);
	    }

	    protected override void OnApplicationFocus(bool hasFocus)
	    {
		    base.OnApplicationFocus(hasFocus);
	    }

		protected override void OnQualitySettingsApplied(int qualitySetting)
        {
            base.OnQualitySettingsApplied(qualitySetting); //Comment out this line if you do not want GM auto scales resolution wrt qualitySetting

            //Handle if any special quality setting change is required. 0 = Worst Quality, 10 = Max Quality
        }
		
#if ROC_DEBUG_MODE || ROC_LOG_MODE
		public void TogglePlayTimeProgress()
		{
			if (!DrawDebugLabel) return;

			DrawTimeLabel = !DrawTimeLabel;
		}

		public void ToggleFPS()
		{
			if (!DrawDebugLabel) return;

			DrawFPSLabel = !DrawFPSLabel;
		}
#endif
    }
}
