﻿using RocketGM.Models;

namespace RocketGM.Utils {
#if ROC_GM_ADJUST
	public class RefSourceConverterBase
    {
        /// <summary>
        /// Converts given refSource to predefined enum values
        /// Override this method according to your needs
        /// </summary>
        /// <param name="refSource"></param>
        /// <returns></returns>
        public virtual RefSource Convert(string refSource) {
            switch (refSource)
            {
                case "Organic":
                    return RefSource.Organic;
                case "Tiktok Ads Android":
                    return RefSource.TiktokAdsAndroid;
                case "Tiktok Ads iOS":
                    return RefSource.TiktokAdsiOS;
                case "Off-Facebook Installs":
                    return RefSource.OffFacebookInstalls;
                case "Facebook Installs":
                    return RefSource.FacebookInstalls;
                case "Instagram Installs":
                    return RefSource.InstagramInstalls;
                case "Adwords UAC Installs":
                    return RefSource.AdwordsUACInstalls;
                case "Snapchat Installs":
                    return RefSource.SnapchatInstalls;
                case "Ironsource":
                    return RefSource.Ironsource;
                case "Adcolony":
                    return RefSource.Adcolony;
                case "Applovin":
                    return RefSource.Applovin;
                case "Mintegral":
                    return RefSource.Mintegral;
                case "Unity":
                    return RefSource.Unity;
                case "Inmobi API":
                    return RefSource.InmobiAPI;
                default:
                    return RefSource.None;
            };
        }
    }
#endif
}

